!compute the density of state D from N0 and Z and the rms magnetization from D 
! by D.Jost 02/10/09

subroutine density(N0,Temp,Z)

implicit none

include 'global.var'

real*8,dimension(Ntemp,N+1,N+1)		::N0
real*8,dimension(Ntemp)				::Z,Temp,N0tot

real*8,dimension(N+1,N+1)		::D !density of state

real*8		::T !current temperature
real*8		::Mrms !mean squared magnetization
real*8		::norm !normalisation factor
integer		::NumberTemp !number of scanned temperature

integer		::i,j,k
real*8		::M,NNC,nom,denom

!compute N0tot
N0tot=0d0
do i=1,Ntemp
	do j=1,N+1
		do k=1,N+1
			N0tot(i)=N0tot(i)+N0(i,j,k)
		end do
	end do
end do

!compute the density of state
do j=1,N+1
	do k=1,N+1
		NNC=4d0*(k-1)-2d0*N
		!***************!
		!***************!
		!***************!
		!***************!
		!***************!
		!***************!
		!***************!
	end do
end do

!save the density of state
open(11,file='DensState.out')
do i=1,N+1
	write(11,*) (D(i,j),j=1,N+1)
end do
close(11)

!compute 

NumberTemp=int((TempMax-TempMin)/dTemp)+1

open(11,file='rmsMag.out')

do k=0,NumberTemp-1
	T=TempMin+k*dTemp !current temperature
	
	!initialize Mag2 and the normalisation factor
	Mrms=0d0
	norm=0d0
	do i=1,N+1
		M=2d0*(i-1)-N !corresponding M value
		do j=1,N+1
			NNC=4d0*(j-1)-2d0*N !corresponding NNC value
			Mrms=Mrms+M**2d0*D(i,j)*dexp(NNC/T)
			norm=norm+D(i,j)*dexp(NNC/T)
		end do
	end do
	!save the normalized rms magnetization
	write(11,*) T,dsqrt(Mrms/norm)/N
	
end do

close(11)

end subroutine density