!Solve the set of implicit equation by iteration
! by D.Jost 02/10/09

subroutine equation(N0,Temp,Z)

implicit none

include 'global.var' !include global variables

real*8,dimension(Ntemp,N+1,N+1)	:: N0
real*8,dimension(Ntemp)			:: Z,Zo,Temp

real*8,dimension(N+1,N+1)		::SN0 !=sum_(i=1..Ntemp) N0(i,:,:)
real*8,dimension(N+1,N+1)		::denom
real*8,dimension(Ntemp)			::N0tot !=sum_(M,NNC) N0(i,M,NNC)

real*8		::M,NNC
integer		::i,j,k,l,Niter,ii

!compute sum_i N0(i,:,:)
SN0=0d0
do i=1,Ntemp
	SN0=SN0+N0(i,:,:)
end do

!compute N0tot
N0tot=0d0
do i=1,Ntemp
	do j=1,N+1
		do k=1,N+1
			N0tot(i)=N0tot(i)+N0(i,j,k)
		end do
	end do
end do

! compute Z

Zo=1d0 !initialize Z
Niter=1000 !number of iteration

do l=1,Niter

	!compute sum_i (N0tot(i)*exp(-beta_i E)/Z_i)
	denom=0d0
	do j=1,N+1
		do k=1,N+1
			NNC=4d0*(k-1)-2d0*N
			do ii=1,Ntemp
				denom(j,k)=denom(j,k)+N0tot(ii)*dexp(NNC/Temp(ii))/Zo(ii)
			end do
		end do
	end do

	!compute the new value of Z
	Z=0d0
	do i=1,Ntemp
		!****************!
		!****************!
		!****************!
		!****************!
		!****************!
		!****************!
	end do
	Zo=Z
	
end do

end subroutine equation
		
	