
!Multicanonical reweighting for the 2D Ising model
! by D.Jost 02/10/09

program maincano

implicit none

include 'global.var' !include global variables

real*8,allocatable		:: SpMtx(:,:) !curent spin matrix
real*8,allocatable		:: N0(:,:) !histograms of visits
real*8,allocatable		:: pi(:,:) !histograms of visits
real*8		::M !current magnetization
real*8		::NNC !current nearest-neighbour coupling

real*8		::tmm,randomnumber !other local variables
integer		::time,i,j !other local variables

call SYSTEM_CLOCK(time)
tmm=real(time)
tmm=tmm/(10d0**(real(int(dlog(tmm)/dlog(10d0)))))
call initializerandomnumbergenerator(tmm)

!open the input file
open(10,file='input.dat')
read(10,*) P !size of the spin matrix
read(10,*) NumberFlip !number of spin flips
read(10,*) TempMin !minimal scanned temperature
read(10,*) TempMax !maximal scanned temperature
read(10,*) dTemp !temperature interval
close(10)

N=P*P

pi=1d0

!initialize the histogram N0
allocate(N0(N+1,N+1)) 
N0=0d0

!generate a random configuration and compute M and NNC
allocate(SpMtx(P,P))
call randomconfig(SpMtx,M,NNC)

do i=1,NumberFlip
	call walk(SpMtx,M,NNC,N0,pi)
end do

!save the histogram
open(11,file='histo.out')
do i=1,N+1
	write(11,*) (N0(i,j),j=1,N+1)
end do
close(11)


!compute the density of state and the rms magnetization from TempMin to TempMax

call density(N0,pi)

end program maincano