!Metropolis scheme
! by D.Jost 15/09/09

subroutine metropolis(SpMtx,M,NNC,N0)

implicit none

include 'global.var'

real*8,dimension(P,P)		::SpMtx
real*8,dimension(N+1,N+1)		::N0
real*8			:: M,NNC

integer		::ir,jr !row and column for the random spin flip
real*8		::dE !free energy difference

real*8		::randomnumber,Sij !other local variables
integer		::im1,jm1,ip1,jp1

!chose randomly a spin
ir=int(P*randomnumber())+1
jr=int(P*randomnumber())+1
Sij=SpMtx(ir,jr)

!compute dE
im1=ir-1
jm1=jr-1
if (im1.eq.0) im1=P
if (jm1.eq.0) jm1=P
ip1=ir+1
jp1=jr+1
if (ip1.eq.(P+1)) ip1=1
if (jp1.eq.(P+1)) jp1=1
dE=2d0*Sij*(SpMtx(ir,jp1)+SpMtx(ip1,jr)+SpMtx(ir,jm1)+SpMtx(im1,jr))

!metropolis criterion
 if (randomnumber().le.(exp(-dE/T0))) then
	!we accept the move
	SpMtx(ir,jr)=-Sij
	M=M-2d0*Sij
	NNC=NNC-dE	
end if

!update the histogram
N0(int((M+N)/2)+1,int((NNC+2*N)/4)+1)=N0(int((M+N)/2)+1,int((NNC+2*N)/4)+1)+1d0	 

end subroutine metropolis